=== debian/changelog ===
sqlitebrowser (3.10.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update for new qscintilla2 library names (Closes: #885635)

 -- Scott Kitterman <scott@kitterman.com>  Thu, 04 Jan 2018 07:02:20 -0500

sqlitebrowser (3.10.1-1) unstable; urgency=medium

  * New upstream version
  * Upstream has fixed plots involving dates (Closes: #826878)
  * Remove previous patches, add a new patch to use system qscintilla2
  * Change priority to optional and bump Standards-Version
  * Apply upstream patch to avoid focus issues with gnome shell
    (Closes: #879926)

 -- Arto Jantunen <viiru@debian.org>  Sat, 04 Nov 2017 13:55:35 +0200
