=== debian/control ===
Source: sqlitebrowser
Section: database
Priority: optional
Maintainer: Arto Jantunen <viiru@debian.org>
Build-Depends: debhelper (>= 10), qtbase5-dev, libsqlite3-dev, cmake, libantlr-dev, qttools5-dev, qttools5-dev-tools, libqscintilla2-qt5-dev
Standards-Version: 4.1.1
Homepage: http://sqlitebrowser.org/
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/sqlitebrowser.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/sqlitebrowser.git

Package: sqlitebrowser
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GUI editor for SQLite databases
 SQLite Database Browser is a visual tool used to create, design and edit
 database files compatible with SQLite. Its interface is based on QT,
 and is meant to be used for users and developers that want to create
 databases, edit and search data using a familiar spreadsheet-like
 interface, without the need to learn complicated SQL commands.
 Controls and wizards are available for users to:
  - Create and compact database files
  - Create, define, modify and delete tables
  - Create, define and delete indexes
  - Browse, edit, add and delete records
  - Search records
  - Import and export records as text
  - Import and export tables from/to CSV files
  - Import and export databases from/to SQL dump files
  - Issue SQL queries and inspect the results
  - Examine a log of all SQL commands issued by the application
 .
 SQLite Database Browser is not a visual shell for the sqlite command line
 tool. It does not require familiarity with SQL commands.
