=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --parallel 

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_TESTING=True -DQSCINTILLA_INCLUDE_DIR=/usr/include/x86_64-linux-gnu/qt5/Qsci/
