## sqlitebrowser 3.11.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,16 @@
 project(sqlitebrowser)
-cmake_minimum_required(VERSION 2.8.7)
+cmake_minimum_required(VERSION 2.8.12.2)
+
+# BUILD_VERSION is the current date in YYYYMMDD format. It is only
+# used by the nightly version to add the date of the build.
+string(TIMESTAMP BUILD_VERSION "%Y%m%d")
+
+# Choose between building a stable version or nightly (the default), depending
+# on whether '-DBUILD_STABLE_VERSION=1' is passed on the command line or not.
+option(BUILD_STABLE_VERSION "Don't build the stable version by default" OFF)
+if(NOT BUILD_STABLE_VERSION)
+    add_definitions(-DBUILD_VERSION=${BUILD_VERSION})
+endif()
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")
 
@@ -12,14 +23,19 @@
 endif()
 
 add_definitions(-std=c++11)
+set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD_REQUIRED True)
+
+# Fix behavior of CMAKE_CXX_STANDARD when targeting macOS.
+if (POLICY CMP0025)
+    cmake_policy(SET CMP0025 NEW)
+endif ()
 
 if(WIN32 AND MSVC)
-	project("DB Browser for SQLite")
 	if(CMAKE_CL_64)
 		# Paths for 64-bit windows builds
 		set(OPENSSL_PATH "C:/dev/OpenSSL-Win64")
-		set(QT5_PATH "C:/dev/Qt/5.7/msvc2013_64")
-		set(VSREDIST "vcredist_x64.exe")
+		set(QT5_PATH "C:/dev/Qt/5.11.3/msvc2017_64")
 
                 # Choose between SQLCipher or SQLite, depending whether
                 # -Dsqlcipher=1 is passed on the command line
@@ -31,8 +47,7 @@
 	else()
 		# Paths for 32-bit windows builds
 		set(OPENSSL_PATH "C:/dev/OpenSSL-Win32")
-		set(QT5_PATH "C:/dev/Qt/5.7/msvc2013")
-		set(VSREDIST "vcredist_x86.exe")
+		set(QT5_PATH "C:/dev/Qt/5.7/msvc2015")
 
                 # Choose between SQLCipher or SQLite, depending whether
                 # -Dsqlcipher=1 is passed on the command line
@@ -43,14 +58,13 @@
                 endif()
 	endif()
 	set(CMAKE_PREFIX_PATH "${QT5_PATH};${SQLITE3_PATH}")
-	set(VSREDIST_DIR "C:/dev/dependencies")
 endif()
 
 if(NOT FORCE_INTERNAL_ANTLR)
-    find_package(Antlr2)
+    find_package(Antlr2 QUIET)
 endif()
 if(NOT FORCE_INTERNAL_QSCINTILLA)
-    find_package(QScintilla)
+    find_package(QScintilla QUIET)
 endif()
 
 set(QHEXEDIT_DIR libs/qhexedit)
@@ -67,9 +81,8 @@
 add_subdirectory(${QHEXEDIT_DIR})
 add_subdirectory(${QCUSTOMPLOT_DIR})
 
-find_package(Qt5Widgets REQUIRED)
-find_package(Qt5LinguistTools REQUIRED)
-find_package(Qt5Network REQUIRED)
+find_package(Qt5 REQUIRED COMPONENTS Concurrent Gui LinguistTools Network PrintSupport Test Widgets Xml)
+
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
@@ -85,6 +98,7 @@
 	src/grammar/sqlite3TokenTypes.hpp
 	src/grammar/Sqlite3Lexer.hpp
 	src/grammar/Sqlite3Parser.hpp
+	src/Data.h
 )
 
 set(SQLB_MOC_HDR
@@ -93,6 +107,7 @@
 	src/EditIndexDialog.h
 	src/EditDialog.h
 	src/EditTableDialog.h
+	src/AddRecordDialog.h
 	src/ExportDataDialog.h
 	src/ExtendedTableWidget.h
 	src/FilterTableHeader.h
@@ -103,7 +118,10 @@
 	src/SqlExecutionArea.h
 	src/VacuumDialog.h
 	src/sqlitetablemodel.h
+	src/RowLoader.h
+	src/RowCache.h
 	src/sqltextedit.h
+	src/docktextedit.h
 	src/DbStructureModel.h
 	src/Application.h
 	src/CipherDialog.h
@@ -118,6 +136,11 @@
 	src/RemoteDock.h
 	src/RemoteModel.h
 	src/RemotePushDialog.h
+	src/FindReplaceDialog.h
+	src/ExtendedScintilla.h
+	src/FileExtensionManager.h
+	src/CipherSettings.h
+	src/DotenvFormat.h
 )
 
 set(SQLB_SRC
@@ -125,6 +148,7 @@
 	src/EditIndexDialog.cpp
 	src/EditDialog.cpp
 	src/EditTableDialog.cpp
+	src/AddRecordDialog.cpp
 	src/ExportDataDialog.cpp
 	src/ExtendedTableWidget.cpp
 	src/FilterTableHeader.cpp
@@ -136,8 +160,10 @@
 	src/VacuumDialog.cpp
 	src/sqlitedb.cpp
 	src/sqlitetablemodel.cpp
+	src/RowLoader.cpp
 	src/sqlitetypes.cpp
 	src/sqltextedit.cpp
+	src/docktextedit.cpp
 	src/csvparser.cpp
 	src/DbStructureModel.cpp
 	src/grammar/Sqlite3Lexer.cpp
@@ -156,6 +182,12 @@
 	src/RemoteDock.cpp
 	src/RemoteModel.cpp
 	src/RemotePushDialog.cpp
+	src/FindReplaceDialog.cpp
+	src/ExtendedScintilla.cpp
+	src/FileExtensionManager.cpp
+	src/Data.cpp
+	src/CipherSettings.cpp
+	src/DotenvFormat.cpp
 )
 
 set(SQLB_FORMS
@@ -163,6 +195,7 @@
 	src/EditIndexDialog.ui
 	src/EditDialog.ui
 	src/EditTableDialog.ui
+	src/AddRecordDialog.ui
 	src/ExportDataDialog.ui
 	src/ImportCsvDialog.ui
 	src/MainWindow.ui
@@ -175,6 +208,8 @@
 	src/PlotDock.ui
 	src/RemoteDock.ui
 	src/RemotePushDialog.ui
+	src/FindReplaceDialog.ui
+	src/FileExtensionManager.ui
 )
 
 set(SQLB_RESOURCES
@@ -198,13 +233,44 @@
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_es_ES.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_fr.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_ru.ts"
+	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_pl.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_pt_BR.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_en_GB.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_ko_KR.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_tr.ts"
 	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_uk_UA.ts"
-)
-
+	"${CMAKE_SOURCE_DIR}/src/translations/sqlb_it.ts"
+)
+
+# Windows image format plugin files
+set(WIN_IMG_PLUGINS
+	"${QT5_PATH}/plugins/imageformats/qgif.dll"
+	"${QT5_PATH}/plugins/imageformats/qicns.dll"
+	"${QT5_PATH}/plugins/imageformats/qico.dll"
+	"${QT5_PATH}/plugins/imageformats/qjpeg.dll"
+	"${QT5_PATH}/plugins/imageformats/qsvg.dll"
+	"${QT5_PATH}/plugins/imageformats/qtga.dll"
+	"${QT5_PATH}/plugins/imageformats/qtiff.dll"
+	"${QT5_PATH}/plugins/imageformats/qwbmp.dll"
+	"${QT5_PATH}/plugins/imageformats/qwebp.dll"
+)
+set(WIN_IMG_PLUGINS_DEBUG
+	"${QT5_PATH}/plugins/imageformats/qgifd.dll"
+	"${QT5_PATH}/plugins/imageformats/qicnsd.dll"
+	"${QT5_PATH}/plugins/imageformats/qicod.dll"
+	"${QT5_PATH}/plugins/imageformats/qjpegd.dll"
+	"${QT5_PATH}/plugins/imageformats/qsvgd.dll"
+	"${QT5_PATH}/plugins/imageformats/qtgad.dll"
+	"${QT5_PATH}/plugins/imageformats/qtiffd.dll"
+	"${QT5_PATH}/plugins/imageformats/qwbmpd.dll"
+	"${QT5_PATH}/plugins/imageformats/qwebpd.dll"
+)
+
+# License files
+set(LICENSE_FILES
+	LICENSE
+	LICENSE-PLUGINS
+)
 
 qt5_wrap_ui(SQLB_FORM_HDR ${SQLB_FORMS})
 if(SQLB_TSS)
@@ -232,6 +298,8 @@
 	ELSE( MINGW )
 		set(SQLB_SRC ${SQLB_SRC} "${CMAKE_CURRENT_SOURCE_DIR}/src/winapp.rc")
 	ENDIF( MINGW )
+else()
+	set(LPTHREAD pthread)
 endif(WIN32)
 
 #enable version check for MacOS
@@ -291,9 +359,6 @@
 		${SQLB_RESOURCES_RCC}
 		${SQLB_MISC})
 
-qt5_use_modules(${PROJECT_NAME} Gui Widgets Network Test PrintSupport)
-set(QT_LIBRARIES "")
-
 add_dependencies(${PROJECT_NAME} qhexedit qcustomplot)
 if(NOT ANTLR2_FOUND)
     add_dependencies(${PROJECT_NAME} antlr)
@@ -313,10 +378,13 @@
     link_directories("${CMAKE_CURRENT_BINARY_DIR}/${QSCINTILLA_DIR}")
 endif()
 
+set(QT_LIBS Qt5::Gui Qt5::Test Qt5::PrintSupport Qt5::Widgets Qt5::Network Qt5::Concurrent Qt5::Xml)
+
 target_link_libraries(${PROJECT_NAME}
 		qhexedit
 		qcustomplot
-		${QT_LIBRARIES}
+    ${LPTHREAD}
+    ${QT_LIBS}
 		${WIN32_STATIC_LINK}
 		${LIBSQLITE}
 		${ADDITIONAL_LIBS})
@@ -332,6 +400,7 @@
 endif()
 
 if(WIN32 AND MSVC)
+	set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME "DB Browser for SQLite")
 	set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_DEBUG "/SUBSYSTEM:CONSOLE")
 	set_target_properties(${PROJECT_NAME} PROPERTIES COMPILE_DEFINITIONS_DEBUG "_CONSOLE")
 	set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_RELWITHDEBINFO "/SUBSYSTEM:CONSOLE")
@@ -340,79 +409,3 @@
         set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:WINDOWS,5.02 /ENTRY:mainCRTStartup")
         set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_MINSIZEREL "/SUBSYSTEM:WINDOWS,5.02")
     else()
-        set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:WINDOWS,5.01 /ENTRY:mainCRTStartup")
-        set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS_MINSIZEREL "/SUBSYSTEM:WINDOWS,5.01")
-    endif()
-endif()
-
-if(NOT WIN32)
-	install(TARGETS ${PROJECT_NAME}
-		RUNTIME DESTINATION bin
-		LIBRARY DESTINATION lib)
-endif()
-
-if(ENABLE_TESTING)
-	add_subdirectory(src/tests)
-endif()
-
-if(UNIX AND NOT APPLE)
-	install(FILES src/icons/${PROJECT_NAME}.png
-		DESTINATION share/icons/hicolor/256x256/apps/)
-	
-	install(FILES distri/${PROJECT_NAME}.desktop
-		DESTINATION share/applications/)
-
-	install(FILES distri/${PROJECT_NAME}.desktop.appdata.xml
-		DESTINATION share/appdata/)
-endif(UNIX AND NOT APPLE)
-
-if(WIN32 AND MSVC)
-	install(TARGETS ${PROJECT_NAME}
-		RUNTIME DESTINATION "/"
-		LIBRARY DESTINATION lib)
-
-	set(QT5_BIN_PATH ${QT5_PATH}/bin)
-	# The Qt5 Debug configuration library files have a 'd' postfix
-	install(FILES
-			${QT5_BIN_PATH}/Qt5Cored.dll
-			${QT5_BIN_PATH}/Qt5Guid.dll
-			${QT5_BIN_PATH}/Qt5Networkd.dll
-			${QT5_BIN_PATH}/Qt5PrintSupportd.dll
-			${QT5_BIN_PATH}/Qt5Widgetsd.dll
-		DESTINATION "/"
-		CONFIGURATIONS Debug)
-	# The Qt5 Release configuration files don't have a postfix
-	install(FILES
-			${QT5_BIN_PATH}/Qt5Core.dll
-			${QT5_BIN_PATH}/Qt5Gui.dll
-			${QT5_BIN_PATH}/Qt5Network.dll
-			${QT5_BIN_PATH}/Qt5PrintSupport.dll
-			${QT5_BIN_PATH}/Qt5Widgets.dll
-		DESTINATION "/"
-		CONFIGURATIONS Release)
-	# The files below are common to all configurations
-	install(FILES
-			${SQLITE3_DLL}
-			${OPENSSL_PATH}/libeay32.dll
-			${OPENSSL_PATH}/ssleay32.dll
-		DESTINATION "/")
-	install(FILES
-		${QT5_PATH}/plugins/platforms/qwindows.dll
-		DESTINATION platforms)
-	install(PROGRAMS "${VSREDIST_DIR}/${VSREDIST}" DESTINATION redist)
-	# The batch file launcher
-	install(FILES
-			distri/winlaunch.bat
-		DESTINATION "/")
-endif()
-
-#cpack
-set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "DB Browser for SQLite")
-set(CPACK_PACKAGE_VENDOR "DB Browser for SQLite Team")
-set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
-set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
-set(CPACK_PACKAGE_VERSION_MAJOR "3")
-set(CPACK_PACKAGE_VERSION_MINOR "10")
-set(CPACK_PACKAGE_VERSION_PATCH "1")
-set(CPACK_PACKAGE_INSTALL_DIRECTORY "DB Browser for SQLite")
-if(WIN32 AND NOT UNIX)
