=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,24 @@
 include_directories("${CMAKE_CURRENT_BINARY_DIR}" ..)
+
+if(NOT WIN32)
+	set(LPTHREAD pthread)
+endif()
 
 # test-sqlobjects
 
 set(TESTSQLOBJECTS_SRC
     ../sqlitedb.cpp
     ../sqlitetablemodel.cpp
+    ../RowLoader.cpp
     ../sqlitetypes.cpp
     ../csvparser.cpp
     ../grammar/Sqlite3Lexer.cpp
     ../grammar/Sqlite3Parser.cpp
     ../Settings.cpp
     testsqlobjects.cpp
+    ../Data.cpp
+    ../CipherSettings.cpp
+    ../DotenvFormat.cpp
 )
 
 set(TESTSQLOBJECTS_HDR
@@ -18,6 +26,7 @@
     ../grammar/Sqlite3Lexer.hpp
     ../grammar/Sqlite3Parser.hpp
     ../sqlitetypes.h
+    ../Data.h
 )
 
 set(TESTSQLOBJECTS_MOC_HDR
@@ -25,6 +34,8 @@
     ../sqlitetablemodel.h
     ../Settings.h
     testsqlobjects.h
+    ../CipherSettings.h
+    ../DotenvFormat.h
 )
 
 if(sqlcipher)
@@ -37,7 +48,9 @@
 
 add_executable(test-sqlobjects ${TESTSQLOBJECTS_MOC} ${TESTSQLOBJECTS_HDR} ${TESTSQLOBJECTS_SRC} ${TESTSQLOBJECTS_FORM_HDR})
 
-qt5_use_modules(test-sqlobjects Test Widgets Gui)
+find_package(Qt5 REQUIRED COMPONENTS Test Widgets Gui)
+target_link_libraries(test-sqlobjects Qt5::Test Qt5::Widgets Qt5::Gui)
+
 set(QT_LIBRARIES "")
 
 if(NOT ANTLR2_FOUND)
@@ -49,9 +62,7 @@
 else()
     target_link_libraries(test-sqlobjects antlr)
 endif()
-link_directories("${CMAKE_CURRENT_BINARY_DIR}/${QSCINTILLA_DIR}")
-add_dependencies(test-sqlobjects qscintilla2)
-target_link_libraries(test-sqlobjects qscintilla2)
+target_link_libraries(test-sqlobjects ${LPTHREAD})
 add_test(test-sqlobjects test-sqlobjects)
 
 # test-import
@@ -67,7 +78,9 @@
 
 add_executable(test-import ${TESTIMPORT_MOC} ${TESTIMPORT_SRC})
 
-qt5_use_modules(test-import Test Core)
+find_package(Qt5 REQUIRED COMPONENTS Core)
+target_link_libraries(test-import Qt5::Test Qt5::Core)
+
 set(QT_LIBRARIES "")
 
 target_link_libraries(test-import ${QT_LIBRARIES})
@@ -78,11 +91,15 @@
 set(TESTREGEX_SRC
     ../sqlitedb.cpp
     ../sqlitetablemodel.cpp
+    ../RowLoader.cpp
     ../sqlitetypes.cpp
     ../grammar/Sqlite3Lexer.cpp
     ../grammar/Sqlite3Parser.cpp
     ../Settings.cpp
     TestRegex.cpp
+    ../Data.cpp
+    ../CipherSettings.cpp
+    ../DotenvFormat.cpp
 )
 
 set(TESTREGEX_HDR
@@ -90,6 +107,7 @@
     ../grammar/Sqlite3Lexer.hpp
     ../grammar/Sqlite3Parser.hpp
     ../sqlitetypes.h
+    ../Data.h
 )
 
 set(TESTREGEX_MOC_HDR
@@ -97,6 +115,8 @@
     ../sqlitetablemodel.h
     ../Settings.h
     TestRegex.h
+    ../CipherSettings.h
+    ../DotenvFormat.h
 )
 
 if(sqlcipher)
@@ -106,7 +126,8 @@
 
 add_executable(test-regex ${TESTREGEX_MOC} ${TESTREGEX_HDR} ${TESTREGEX_SRC})
 
-qt5_use_modules(test-regex Test Core Gui Widgets)
+target_link_libraries(test-regex Qt5::Test Qt5::Core Qt5::Gui Qt5::Widgets)
+
 set(QT_LIBRARIES "")
 
 if(NOT ANTLR2_FOUND)
@@ -118,7 +139,24 @@
 else()
     target_link_libraries(test-regex antlr)
 endif()
-link_directories("${CMAKE_CURRENT_BINARY_DIR}/${QSCINTILLA_DIR}")
-add_dependencies(test-regex qscintilla2)
-target_link_libraries(test-regex qscintilla2)
+target_link_libraries(test-regex ${LPTHREAD})
 add_test(test-regex test-regex)
+
+# test cache
+
+set(TESTCACHE_SRC
+    TestRowCache.cpp
+)
+
+set(TESTCACHE_MOC_HDR
+    TestRowCache.h
+)
+
+add_executable(test-cache ${TESTCACHE_MOC} ${TESTCACHE_SRC})
+
+target_link_libraries(test-cache Qt5::Test Qt5::Core)
+
+set(QT_LIBRARIES "")
+
+target_link_libraries(test-cache ${QT_LIBRARIES})
+add_test(test-cache test-cache)
