=== libs/qscintilla/Qt4Qt5/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,13 @@
-cmake_minimum_required(VERSION 2.8.7)
+cmake_minimum_required(VERSION 2.8.12.2)
 
-set(CMAKE_AUTOMOC ON)
+# Disable AUTOMOC because it cannot be made to work with QScintilla
+set(CMAKE_AUTOMOC OFF)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
-find_package(Qt5Widgets REQUIRED)
+
+find_package(Qt5 REQUIRED COMPONENTS PrintSupport Widgets)
 
 if(APPLE)
-    find_package(Qt5MacExtras)
+    find_package(Qt5 REQUIRED COMPONENTS MacExtras)
 endif()
 
 add_definitions(-DSCINTILLA_QT)
@@ -22,6 +24,12 @@
 	qscilexer.cpp
 	qscilexercustom.cpp
 	qscilexersql.cpp
+	qscilexerjson.cpp
+	qscilexerhtml.cpp
+	qscilexerxml.cpp
+	qscilexerjavascript.cpp
+	qscilexercpp.cpp
+	qscilexerpython.cpp
 	qscimacro.cpp
 	qsciprinter.cpp
 	qscistyle.cpp
@@ -33,6 +41,8 @@
 	PlatQt.cpp
 	ScintillaQt.cpp
 	../lexers/LexSQL.cpp
+	../lexers/LexJSON.cpp
+	../lexers/LexHTML.cpp
 	../lexlib/Accessor.cpp
 	../lexlib/CharacterCategory.cpp
 	../lexlib/CharacterSet.cpp
@@ -143,17 +153,25 @@
 	./Qsci/qscilexer.h
 	./Qsci/qscilexercustom.h
 	./Qsci/qscilexersql.h
+	./Qsci/qscilexerjson.h
+	./Qsci/qscilexerhtml.h
+	./Qsci/qscilexerxml.h
+	./Qsci/qscilexerjavascript.h
+	./Qsci/qscilexercpp.h
+	./Qsci/qscilexerpython.h
 	./Qsci/qscimacro.h
 	SciClasses.h
 	ScintillaQt.h
 )
 
+QT5_WRAP_CPP(QSCINTILLA_WRAP_MOC_HDR ${QSCINTILLA_MOC_HDR})
+
 include_directories(. ../include ../lexlib ../src)
 
-add_library(qscintilla2 ${QSCINTILLA_SRC} ${QSCINTILLA_HDR} ${QSCINTILLA_MOC_HDR} ${QSCINTILLA_MOC})
+add_library(qscintilla2 ${QSCINTILLA_SRC} ${QSCINTILLA_HDR} ${QSCINTILLA_MOC_HDR} ${QSCINTILLA_MOC} ${QSCINTILLA_WRAP_MOC_HDR})
+
+target_link_libraries(qscintilla2 Qt5::Widgets Qt5::PrintSupport)
 
 if (APPLE)
-	qt5_use_modules(qscintilla2 Widgets PrintSupport MacExtras)
-else()
-	qt5_use_modules(qscintilla2 Widgets PrintSupport)
+	target_link_libraries(qscintilla2 Qt5::MacExtras)
 endif()
