=== debian/changelog ===
sqlitebrowser (3.11.2-1build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:26:11 +0100

sqlitebrowser (3.11.2-1build1) focal; urgency=medium

  * No-change rebuild against libqscintilla2-qt5-15.

 -- Rik Mills <rikmills@kde.org>  Thu, 21 Nov 2019 09:53:02 +0000

sqlitebrowser (3.11.2-1) unstable; urgency=medium

  * New upstream version
  * Remove patch 0002, applied upstream.
  * Refresh the system libraries patch
  * Update to debhelper 12
  * Bump Standards-Version to 4.4.0

 -- Arto Jantunen <viiru@debian.org>  Sun, 28 Jul 2019 14:50:58 +0300

sqlitebrowser (3.10.1-2) unstable; urgency=medium

  * Point VCS urls to Salsa
  * Update system qscintilla2 library names
  * Bump Standards-Version to 4.1.5, no changes
  * Update to debhelper compat level 11
  * Enable all hardening options

 -- Arto Jantunen <viiru@debian.org>  Thu, 02 Aug 2018 21:10:47 +0300
