=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: database
 Priority: optional
 Maintainer: Arto Jantunen <viiru@debian.org>
-Build-Depends: debhelper (>= 10), qtbase5-dev, libsqlite3-dev, cmake, libantlr-dev, qttools5-dev, qttools5-dev-tools, libqscintilla2-qt5-dev
-Standards-Version: 4.1.1
+Build-Depends: debhelper-compat (= 12), qtbase5-dev, libsqlite3-dev, cmake, libantlr-dev, qttools5-dev, qttools5-dev-tools, libqt5scintilla2-dev
+Standards-Version: 4.4.0
 Homepage: http://sqlitebrowser.org/
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/sqlitebrowser.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/sqlitebrowser.git
+Vcs-Browser: https://salsa.debian.org/sqlitebrowser-team/sqlitebrowser
+Vcs-Git: https://salsa.debian.org/sqlitebrowser-team/sqlitebrowser.git
 
 Package: sqlitebrowser
 Architecture: any
